#ifndef __PATTERN_P_H__
#define __PATTERN_P_H__

#include "Pattern.h"




struct _PatternType {
	const char* name;
	int basic_size;
	int (*initialize)(Pattern* self, const char* arg);
	void (*finalize)(Pattern* self);
	int (*match_wp)(const Pattern* self, WPARAM wp);
	int (*match_lp)(const Pattern* self, LPARAM lp);
	int (*calc_instance_size)(const PatternType* type, const char* arg);
};

void Pattern_Finalize_NothingToDo(Pattern*);
int Pattern_CalcInstanceSize_Simple(const PatternType*, const char*);




#define Pattern_HEAD	\
	const PatternType* type;

struct _Pattern {
	Pattern_HEAD
};




#endif
